<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Util\Functions;

class RelMoviProdHoraService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    private function setParameters($conditions) {
        
    	$array = array (
    	    
            ':DTINI' => $conditions['DTENTRVENDA'][0], 
            ':DTFIN' => $conditions['DTENTRVENDA'][1], 
            ':CDFILIAL' => is_array($conditions['CDFILIAL']) ? implode(', ' ,$conditions['CDFILIAL']) : ($conditions['CDFILIAL'] ),
            ':TCDFILIAL' => Functions::arrayKeyExists('CDFILIAL', $conditions) && !empty($conditions['CDFILIAL']) ? 'N' : 'T',
            ':NRORG' => $conditions['NRORG'], 
            ':TCDPRODUTO' => $conditions['TCDPRODUTO'],
            ':CDPRODLIST' => $conditions['CDPRODLIST'],
            ':CDARVPRODF' => $conditions['CDARVPRODF'],
            ':CDARVPRODI' => $conditions['CDARVPRODI'],
            ':CDNVPRODUTO' => str_replace('%', '', $conditions['CDNVPRODUTO']),
            ':CDNVPRODUTOAGRUP' => str_replace('%', '', $conditions['CDNVPRODUTOAGRUP']),
            ':PRODNIV' => $conditions['PRODNIV'],
            ':CDCLIENTE' => Functions::arrayKeyExists('CDCLIENTE', $conditions) && !empty($conditions['CDCLIENTE']) ? implode('_',$conditions['CDCLIENTE']) : '' ,
            ':TCDCLIENTE' => Functions::arrayKeyExists('CDCLIENTE', $conditions) && !empty($conditions['CDCLIENTE']) ? 'N' : 'T',
            ':CDCONSUMIDOR' => Functions::arrayKeyExists('CDCONSUMIDOR', $conditions) && !empty($conditions['CDCONSUMIDOR']) ? implode('_',$conditions['CDCONSUMIDOR']) : '' ,
            ':TCDCONSUMIDOR' => Functions::arrayKeyExists('CDCONSUMIDOR', $conditions) && !empty($conditions['CDCONSUMIDOR']) ? 'N' : 'T',
            ':CDTIPOCONS' => Functions::arrayKeyExists('CDTIPOCONS', $conditions) && !empty($conditions['CDTIPOCONS']) ? implode('_',$conditions['CDTIPOCONS']) : '' ,
            ':TCDTIPOCONS' => Functions::arrayKeyExists('CDTIPOCONS', $conditions) && !empty($conditions['CDTIPOCONS']) ? 'N' : 'T'
        );
        return $array;
        
    }
    
    public function getData($conditions){
        $params = self::setParameters($conditions);
        return  $this->entityManager->getConnection()->fetchAll(self::REL_PRODUTOS_POR_HORA, $params);
    }
    
    const REL_PRODUTOS_POR_HORA = "
       SELECT DISTINCT P.CDPRODUTO, P.NMPRODUTO, P.CDPRODUTOAVO, P.NMPRODUTOAVO, 
        TO_CHAR(IT.DTHRPEDIDO, 'HH24') AS HORAPEDIDO, SUM(IT.QTPRODVEND) AS TOT, SUM((IT.QTPRODVEND * IT.VRUNITVEND) - VRDESITVEND) TOTALVEND, V.CDFILIAL, 
        V.CDFILIAL|| ' - ' || V.NMFILIAL AS LABELFILIAL, 0 AS TOTAL, 0 AS HR00, 0 AS HR01, 0 AS HR02, 0 AS HR03,
        0 AS HR04, 0 AS HR05, 0 AS HR06, 0 AS HR07, 0 AS HR08, 0 AS HR09, 0 AS HR10, 0 AS HR11, 0 AS HR12, 0 AS HR13, 0 AS HR14, 
        0 AS HR15, 0 AS HR16, 0 AS HR17, 0 AS HR18, 0 AS HR19, 0 AS HR20, 0 AS HR21, 0 AS HR22, 0 AS HR23, P.CDPRODUTO || ' - ' || P.NMPRODUTO AS LABELPRODUTO, V.CDCLIENTE, V.CDCONSUMIDOR, C.NMCONSUMIDOR, C.CDTIPOCONS
        FROM (
                SELECT  PF.CDPRODUTO, PF.NMPRODUTO, PF.CDARVPROD, 
                        PV.CDPRODUTO AS CDPRODUTOAVO, PV.NMPRODUTO AS NMPRODUTOAVO, PF.NRORG,
                        PV.CDNVPRODUTO
                  FROM PRODUTO PF
                  JOIN PRODUTO PV
                    ON PF.CDARVPROD LIKE PV.CDARVPROD||'%'
                   AND PV.CDNVPRODUTO = :CDNVPRODUTOAGRUP
                   AND PF.NRORG = PV.NRORG
                   AND PV.NRORG = :NRORG
            ) P
        JOIN ITEMVENDA IT
          ON IT.CDPRODUTO = P.CDPRODUTO
        JOIN (SELECT V.CDCLIENTE, V.CDCONSUMIDOR, FILOCA.CDFILIAL, FILOCA.NMFILIAL, FILOCA.CDCAIXA, V.NRSEQVENDA  FROM VENDA V
                JOIN (SELECT FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.CDLOJA, C.CDCAIXA
                         FROM CAIXA C
                         JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV
                                 FROM LOJA L
                                 JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG
                                         FROM FILIAL F
                                        WHERE ((INSTR(:CDFILIAL, F.CDFILIAL)> 0) OR (:TCDFILIAL = 'T'))
                                          AND F.NRORG =:NRORG ) FI 
                                   ON L.CDFILIAL = FI.CDFILIAL
                                  AND L.NRORG = FI.NRORG) FILO 
                           ON C.CDFILIAL = FILO.CDFILIAL 
                          AND C.CDLOJA = FILO.CDLOJA
                          AND C.NRORG = FILO.NRORG) FILOCA
              ON V.CDFILIAL = FILOCA.CDFILIAL
              AND V.CDCAIXA = FILOCA.CDCAIXA
              AND V.CDLOJA = FILOCA.CDLOJA
           WHERE  ((INSTR(:CDCONSUMIDOR, V.CDCONSUMIDOR)> 0) OR (:TCDCONSUMIDOR = 'T'))
             AND ((INSTR(:CDCLIENTE, V.CDCLIENTE)> 0) OR (:TCDCLIENTE = 'T'))     
             AND V.IDSITUVENDA = 'O'
             AND TRUNC(V.DTVENDA) BETWEEN TRUNC(TO_DATE(:DTINI, 'DD/MM/YYYY')-1) AND TRUNC(TO_DATE(:DTFIN, 'DD/MM/YYYY')+1)
              ) V   
          ON IT.NRSEQVENDA = V.NRSEQVENDA
         AND IT.CDFILIAL = V.CDFILIAL
         AND IT.CDCAIXA = V.CDCAIXA   
        LEFT JOIN CONSUMIDOR C
          ON C.CDCLIENTE = V.CDCLIENTE
         AND C.CDCONSUMIDOR = V.CDCONSUMIDOR
       WHERE IT.DTHRPEDIDO IS NOT NULL
         AND ((INSTR(:CDTIPOCONS, C.CDTIPOCONS)> 0) OR (:TCDTIPOCONS = 'T'))  
         AND TRUNC(IT.DTHRPEDIDO) BETWEEN :DTINI AND :DTFIN
         AND (((INSTR(:CDPRODLIST, P.CDPRODUTO) > 0 )  OR 
                 (P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF)) OR 
                 (P.CDARVPROD LIKE :PRODNIV) OR
                 (:TCDPRODUTO = 'T')) 
         GROUP BY P.CDPRODUTO, P.NMPRODUTO, P.CDPRODUTOAVO, P.NMPRODUTOAVO,  V.CDFILIAL, V.CDCLIENTE, V.CDCONSUMIDOR , C.NMCONSUMIDOR, C.CDTIPOCONS,
        TO_CHAR(IT.DTHRPEDIDO, 'HH24'), V.CDFILIAL|| ' - ' || V.NMFILIAL,  P.CDPRODUTO || ' - ' || P.NMPRODUTO
      ORDER BY P.CDPRODUTO, HORAPEDIDO
    ";
}